#include "stdafx.h"
#include "ScanFinger.h"
#include "MainFrm.h"
#include "ScanFingerDoc.h"
#include "ScanFingerView.h"
#include "ScanFingerInfoView.h"
#include <array>


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#pragma warning(suppress: 26409 26433 26440 26477)
IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_CREATE()
  ON_MESSAGE(WM_ACQUIRED_SAMPLE, &CMainFrame::OnAcquiredSample)
END_MESSAGE_MAP()

std::array<UINT, 4> g_indicators
{ {
  ID_SEPARATOR,
  ID_INDICATOR_CAPS,
  ID_INDICATOR_NUM,
  ID_INDICATOR_SCRL,
} };

#pragma warning(suppress: 26434)
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  //Let the base class do its thing
  if (__super::OnCreate(lpCreateStruct) == -1)
    return -1;

  //Create the toolbar
  if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP | CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
      !m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
  {
    TRACE(_T("Failed to create toolbar\n"));
    return -1;
  }

  //Create the statusbar
  if (!m_wndStatusBar.Create(this))
  {
    TRACE(_T("Failed to create status bar\n"));
    return -1;
  }
#pragma warning(suppress: 26472)
  m_wndStatusBar.SetIndicators(g_indicators.data(), static_cast<int>(g_indicators.size()));

  m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
  EnableDocking(CBRS_ALIGN_ANY);
  DockControlBar(&m_wndToolBar);

  return 0;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT /*lpcs*/, CCreateContext* pContext)
{
  //Get the client rect so that we can position the views.
  CRect ClientRect;
  GetClientRect(&ClientRect);

  //Create the horizontal splitter
  if (!m_wndSplitter.CreateStatic(this, 1, 2))
    return FALSE;

  //Add the right hand view
  if (!m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS(CScanFingerInfoView), CSize{ClientRect.Width()/2, ClientRect.Height()}, pContext))
    return FALSE;

  //Add the left hand view
  if (!m_wndSplitter.CreateView(0, 1, RUNTIME_CLASS(CScanFingerView), CSize{ClientRect.Width()/2, ClientRect.Height()}, pContext))
    return FALSE;

  return TRUE;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
  cs.style &= ~FWS_ADDTOTITLE; //Do not add the document name to the caption

  //Let the base class do its thing
  return __super::PreCreateWindow(cs);
}

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
  __super::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
  __super::Dump(dc);
}
#endif //_DEBUG

LRESULT CMainFrame::OnAcquiredSample(WPARAM wParam, LPARAM /*lParam*/)
{
#pragma warning(suppress: 26472)
  const auto hr{static_cast<HRESULT>(wParam)};
  if (SUCCEEDED(hr))
  {
    //Start a new scan but leave the current information intact
    theApp.StartNewScan(false);
  }
  else
  {
    //If the scan failed, do not initiate another scan, but just update the views
#pragma warning(suppress: 26429)
    CDocument* pDoc{GetActiveDocument()};
    ASSERT(pDoc != nullptr);
    pDoc->UpdateAllViews(nullptr);
  }

  return 0L;
}
