#pragma once


class CScanFingerDoc;


class CScanFingerView : public CScrollView
{
protected:
  CScanFingerView() noexcept;

public:
//Constructors / Destructors
  CScanFingerView(const CScanFingerView&) = delete;
  CScanFingerView(CScanFingerView&&) = delete;
  ~CScanFingerView() = default; //NOLINT(modernize-use-override)

//Methods
  CScanFingerView& operator=(const CScanFingerView&) = delete;
  CScanFingerView& operator=(CScanFingerView&&) = delete;
  [[nodiscard]] CScanFingerDoc* GetDocument() const;
  void OnDraw(CDC* pDC) override;
#ifdef _DEBUG
  void AssertValid() const override;
  void Dump(CDumpContext& dc) const override;
#endif
  void OnInitialUpdate() override;
  void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) override;

protected:
//Member variables
  UINT m_nCurrentZoomLevel;
  bool m_bSizeToFit;

//Methods
  BOOL PreTranslateMessage(MSG* pMsg) override;
  HGLOBAL DDBToDIB(_In_ const CBitmap* pBitmap, _In_opt_ CPalette* pPalette);
  CSize DrawSize(_In_ const CRect& rClient);

//Message handlers
  afx_msg void OnEditCopy();
  afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
  afx_msg BOOL OnEraseBkgnd(CDC* pDC);
  afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
  afx_msg void OnZoomZoomin();
  afx_msg void OnZoomZoomout();
  afx_msg void OnUpdateZoomZoomin(CCmdUI* pCmdUI);
  afx_msg void OnUpdateZoomZoomout(CCmdUI* pCmdUI);
  afx_msg void OnZoomActual();
  afx_msg void OnUpdateZoomActual(CCmdUI* pCmdUI);
  afx_msg void OnZoomBestfit();
  afx_msg void OnUpdateZoomBestfit(CCmdUI* pCmdUI);
  afx_msg void OnSize(UINT nType, int cx, int cy);

  DECLARE_MESSAGE_MAP()

  DECLARE_DYNCREATE(CScanFingerView)
};
